unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, 
  Dialogs, StdCtrls, SuggestEdit;

type

  { TForm1 }

  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    procedure FormCreate({%H-}Sender: TObject);
    procedure FormDestroy({%H-}Sender: TObject);
    procedure FormShow({%H-}Sender: TObject);
  private
    FSearchWordsFile: String;
    FSearchWords: TStringList;
  public
    procedure SuggestEditDeleteItem(Sender: TObject; const AText: String);
    procedure SuggestEditEditingDone(Sender: TObject);
    procedure SuggestEditEnter(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
var
  aSuggestEdit: TSuggestEdit;
begin
  aSuggestEdit := TSuggestEdit.Create(Self);
  aSuggestEdit.BorderSpacing.Around := 10;
  aSuggestEdit.Align := alTop;
  aSuggestEdit.MaxBoxPreviewCount := 50;
  aSuggestEdit.MaxBoxHeight := 200;
  aSuggestEdit.Parent := Self;
  aSuggestEdit.SetFocus;
  aSuggestEdit.OnEditingDone := @SuggestEditEditingDone;
  aSuggestEdit.OnEnter := @SuggestEditEnter;
  aSuggestEdit.OnDeleteItem := @SuggestEditDeleteItem;
  aSuggestEdit.Items.Assign(FSearchWords);
end;

procedure TForm1.SuggestEditDeleteItem(Sender: TObject; const AText: String);
var
  i: Integer;
begin
  i := FSearchWords.IndexOf(AText);
  if i = -1 then Exit;
  FSearchWords.Delete(i);
  TSuggestEdit(Sender).Items.Assign(FSearchWords);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FSearchWordsFile := GetCurrentDir + PathDelim + 'vornamen.txt';
  FSearchWords := TStringList.Create;
  if FileExists(FSearchWordsFile) then
    FSearchWords.LoadFromFile(FSearchWordsFile);
  FSearchWords.Sort;
  FSearchWords.Sorted := True;
  ComboBox1.Items.Assign(FSearchWords);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FSearchWords.SaveToFile(FSearchWordsFile);
  FSearchWords.Free;
end;

procedure TForm1.SuggestEditEditingDone(Sender: TObject);
var
  s: String;
begin
  s := TSuggestEdit(Sender).Text;
  if FSearchWords.IndexOf(s) >= 0 then Exit;
  FSearchWords.Add(s);
  TSuggestEdit(Sender).Items.Assign(FSearchWords);
end;

procedure TForm1.SuggestEditEnter(Sender: TObject);
begin
  TSuggestEdit(Sender).Items.Assign(FSearchWords);
end;

end.

